module Main
where

import Test.Tasty ( TestTree, defaultMain, localOption, testGroup )
import Test.Tasty.QuickCheck ( QuickCheckTests(..) )

import Cardinal ( cardinal_tests, cardinal_properties )
import Cube ( cube_properties )
import FunctionValues ( function_values_tests, function_values_properties )
import Grid ( grid_properties, grid_tests, slow_tests )
import Misc ( misc_tests, misc_properties )
import Tetrahedron ( tetrahedron_tests, tetrahedron_properties )

main :: IO ()
main = do
  defaultMain $ localOption (QuickCheckTests 500) tests


tests :: TestTree
tests =
  testGroup "All tests"
    [ cardinal_tests,
      function_values_tests,
      grid_tests,
      misc_tests,
      tetrahedron_tests,
      grid_properties,
      cube_properties,
      tetrahedron_properties,
      misc_properties,
      cardinal_properties,
      slow_tests ]
